/*
 *	init.js - initializing the skin, skin-specific utilities
 *	Author: Laza
 */
 
var JAFilter = Java.type("se.datadosen.jalbum.JAFilter"),
	FixedShapeFilter = Java.type("FixedShapeFilter"),
	Zip = Java.type(skin.toLowerCase().split(' ')[0] + ".Zip");
	
	// Undefined
	UNDEF = 'undefined';

 	// URL-encoding should be always on
	engine.setUrlEncode(true);
	
	// Zip library
	var zip = new Zip(engine);
	engine.setUsing(zip);
	
	// Making folder thumbs fixed shape
	if (fixedShapeThumbs || folderPlacement !== 'mixed') {
		engine.addFilter(new FixedShapeFilter(), JAFilter.FOLDERS_PRESCALE_STAGE);
	}
	
	// Directory chaning must be turned ON if afterLast is not "loop"
	var DirectoryChaining = Java.type("se.datadosen.jalbum.DirectoryChaining");
	if (afterLast !== 'loop' && engine.getDirectoryChaining().equals(DirectoryChaining.NO_CHAINING)) {	
		engine.setDirectoryChaining(DirectoryChaining.SIBLINGS);
	}
	
	// Icon themes
	pageIconTheme = isLightColor(pageBgColor)? 'dark' : 'light';
	sidebarIconTheme = isLightColor(sidebarBgColor)? 'dark' : 'light';
	secondaryIconTheme = isLightColor(secondaryBgColor)? 'dark' : 'light';
	
	// Icon
	icon_menu =	'<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><path d="M22,3.5V5H2V3.5ZM2,13H22V11.5H2Zm0,8H22V19.5H2Z" fill="#eee" fill-rule="evenodd"/></svg>';
	icon_home =	'<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><path d="M18.5,21H5.5V13h-4L12,2.5,22.5,13h-4ZM17,19.5v-8h1.88L12,4.62,5.12,11.5H7v8Z" fill="#eee"/></svg>';
	icon_up = '<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><path d="M14.75,19.5A3.75,3.75,0,0,1,11,15.75V6.37l5.12,5.12,1.06-1.06L10.25,3.5,3.32,10.43l1.06,1.06L9.5,6.37v9.38A5.26,5.26,0,0,0,14.75,21H22V19.5Z" fill="#eee"/></svg>';
	icon_prev =	'<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><polygon points="23 11.25 4.87 11.25 12.93 3.19 11.87 2.13 2 12 11.87 21.87 12.93 20.81 4.87 12.75 23 12.75 23 11.25" fill="#eee"/></svg>';
	icon_next =	'<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><polygon points="2 11.25 20.13 11.25 12.07 3.19 13.13 2.13 23 12 13.13 21.87 12.07 20.81 20.13 12.75 2 12.75 2 11.25" fill="#eee"/></svg>';
	icon_first = '<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><polygon points="23 11.25 9.87 11.25 15.93 5.19 14.87 4.13 7 12 14.87 19.87 15.93 18.81 9.87 12.75 23 12.75 23 11.25" fill="#eee"/><rect x="3" y="3" width="1.5" height="18" fill="#eee"/></svg>';
	icon_last =	'<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><polygon points="1 11.25 14.13 11.25 8.07 5.19 9.13 4.13 17 12 9.13 19.87 8.07 18.81 14.13 12.75 1 12.75 1 11.25" fill="#eee"/><rect x="19.5" y="3" width="1.5" height="18" transform="translate(40.5 24) rotate(-180)" fill="#eee"/></svg>';
		
	// Has subfolders or a simple album
	albumHasFolders = JAlbumUtilities.countCategories(rootFolder, false).getCount(Category.folder) > 0;
	
	// Has sidebar
	hasSidebar = folderPlacement === 'sidebar' || pagePlacement === 'sidebar' || webLocationPlacement === 'sidebar';
	
	// Has top bar
	hasTopbar = folderPlacement === 'top' || pagePlacement === 'top' || webLocationPlacement === 'top';
	
	// Has sharing options
	hasShare = shareFacebook || shareTwitter || shareLinkedIn || sharePinterest || shareReddit || shareEmail || shareLink;
	
	// Create a stripped album description for use in a meta tag
	strippedAlbumDescription = stripHTML(albumDescription);
	
	photodataTemplate = "# Creator & rights\n" +
		"Creator: xmp.dc:creator|photographer|artist|Artist|Owner|xmp.aux:OwnerName|Creator|Xmp.Author|Iptc.IIM/Creator\n" +
		"Credit: xmp.dc:credit|Credit|Iptc.IIM/CreditLine\n" +
		"Rights: xmp.dc:rights|rights|xmp.xmpRights:UsageTerms|Iptc.IIM/Usage Terms\n" +
		"Copyright: Copyright|Iptc.Copyright Notice|Iptc.IIM/CopyrightNotice\n" +
		"# Title\n" +
		"Title: xmp.dc:title|Xmp.Title|objectName|Iptc.IIM/ObjectName|Xmp.UserComment\n" +
		"Headline: xmp.photoshop:Headline|Headline|Iptc.IIM/Headline\n" +
		"# Description\n" +
		"Description: xmp.dc:description|ImageDescription|Xmp.Description|Xmp.Subject|Iptc.IIM/Caption/Abstract\n" +
		"Category: xmp.photoshop:Category|Category|Iptc.IIM/Category\n" +
		"# Keywords\n" +
		"Keywords: xmp.dc:subject|keywords|Iptc.IIM/Keywords\n" +
		"Identifier: xmp.dc:identifier|Xmp.Identifier\n" +
		"Label: Xmp.Label\n" +
		"# Location\n" +
		"Country: xmp.photoshop:Country|Country|Country/Primary Location|Country/Primary Location Name|Iptc.IIM/Country\n" +
		"State: xmp.photoshop:State|Province/State|Iptc.IIM/Province/State\n" +
		"City: xmp.photoshop:City|City|Iptc.IIM/City\n" +
		"Sub-location: Sub-location|Iptc.IIM/Sub-Location\n" +
		"# Camera\n" +
		"Date/Time: originalDate|Date/Time Original|Date/Time|CreateDate|ModifyDate\n" +
		"Make: Make\n" +
		"Model: Model|Camera\n" +
		"Lens: lens|Lens|Lens Model|Canon makernote.Lens Model|Xmp.Lens-Information|xmp.aux:Lens|Lens Specification\n" +
		"Focal length: focalLength35mm|focusDistance|Focal Length|Focallength\n" +
		"Distance: SubjectDistance\n" +
		"Metering mode: meteringMode|Metering Mode\n" +
		"ISO equivalent: isoEquivalent|ISO Speed Ratings\n" +
		"Exposure time: exposureTime|Exposure Time|Shutter Speed Value|ShutterSpeedValue\n" +
		"Aperture: Aperture Value|aperture|F-Number|FNumber|Aperturevalue\n" +
		"Exposure bias: Exposure Bias Value\n" +
		"Exposure program: Exposure Program|Exposureprogram|Exposure Mode\n" +
		"Scene type: Xmp.SceneType\n" +
		"White balance: White Balance|WhiteBalance\n" +
		"Color space: Xmp.ColorSpace\n" +
		"Light source: Xmp.LightSource\n" +
		"Flash: flash|Flash\n" +
		"Resolution: resolution\n";
		
	processFile('justify.js', 'res/justify.js');
	
	/* Initializing variables for CSS files */
	
	if (!useLineborder) {
		borderWidth = 0;
		borderPadding = 0;
		boxShadow = dropShadow? ((getLuminosity(pageBgColor) > 0.6)? '1px 3px 6px rgba(0,0,0,0.3)' : '1px 3px 6px rgba(0,0,0,0.6)') : 'none';
		cardBgColor = 'transparent';
		cardBoxShadow = 'none';
		cardBorderRadius = borderRounding? (borderRounding + 'px') : '0';
		borderRadius = cardBorderRadius;
	} else {
		boxShadow = 'none';
		cardBgColor = borderPadding? 'transparent' : borderColor;
		cardBoxShadow = dropShadow? ((getLuminosity(pageBgColor) > 0.6)? '1px 3px 6px rgba(0,0,0,0.3)' : '1px 3px 6px rgba(0,0,0,0.6)') : 'none';
		cardBorderRadius = borderRounding? (borderRounding + 'px') : '0';
		borderRadius = borderRounding? (Math.max(borderRounding - borderPadding - borderWidth, 0) + 'px') : '0';
	}
	boldWeight = Math.min(fontWeight + 300, 900);
	minThumbWidth = fixedShapeThumbs? Math.round(maxThumbWidth * .7) : maxThumbWidth;
	minThumbHeight = fixedShapeThumbs? Math.round(maxThumbHeight * .7) : maxThumbHeight;
	thumbboxWidth = minThumbWidth + 2 * (borderPadding + borderWidth);
	thumbnailsWidth = cols * (2 * thumbSpacing + thumbboxWidth) + 2 * contentPadding;
	maxPageWidth = Math.min(thumbnailsWidth, 960);
	transparentText = setAlpha(secondaryTextColor, 0.25);
	accentTextColor = (getLuminosity(accentColor) > 0.6)? '#222222' : '#ffffff';
	linkColor = getLegibleColor(pageBgColor, accentColor, 0.4);
	sidebarActualBg = (getLuminosity(sidebarBgColor) > 0.6)? 'rgba(0,0,0,.1)' : 'rgba(255,255,255,.15)';
	lightboxBg = getCssColor(setAlpha(lightboxBgColor, 1));
	if (isLightColor(lightboxBgColor)) {
		buttonBg = 'rgba(255,255,255,.35)';
		buttonColor = '#222222';
		buttonColorSec = 'rgba(34,34,34,.5)';
		buttonHoverBg = 'rgba(255,255,255,.75)';
		captionBg = 'rgba(255,255,255,.94)';
		captionColor = '#222222';
	} else {
		buttonBg = 'rgba(0,0,0,.25)';
		buttonColor = '#f4f4f4';
		buttonColorSec = 'rgba(244,244,244,.5)';
		buttonHoverBg = 'rgba(0,0,0,.75)';
		captionBg = 'rgba(16,16,16,.94)';
		captionColor = '#f4f4f4';
	}
	fontFamilyCss = (fontFamily.charAt(0) == '_')? ("'" + fontFamily.substring(1) + "',sans-serif") : fontFamily;
	
	processFile('main.js', 'res/main.js');

	