package tiger;

import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import se.datadosen.component.JPlaylist;
import se.datadosen.component.JSmartTextArea;
import se.datadosen.jalbum.AlbumObject;
import se.datadosen.jalbum.Category;
import se.datadosen.jalbum.JAlbumContext;
import se.datadosen.jalbum.JCustomPanel;
import se.datadosen.util.SmartResourceBundle;

/**
 *
 * @author Laza
 */

public class ImageDataUI extends JCustomPanel {

	JPlaylist backgroundAudioLocal = new JPlaylist();
	JLabel backgroundAudioLabel = new JLabel();
	JCheckBox useInSlider = new JCheckBox();
	JCheckBox panorama = new JCheckBox();
	JCheckBox hideLocation = new JCheckBox();
	//JComboBox fotomotoCollection = new JComboBox();
	//JLabel fotomotoCollectionLabel = new JLabel();
	JCheckBox hideFotomoto = new JCheckBox();
	JTextArea shopOptionsLocal = new JSmartTextArea(4, 4);
	JScrollPane shopPane = new JScrollPane(shopOptionsLocal);
	JTextField shopDiscountRateLocal = new JTextField(4);
	JTextField shopQuantityCapLocal = new JTextField(4);
	
	@Override
	public void setAlbumObject(AlbumObject ao) {
			
		super.setAlbumObject(ao);
			
		if (ao != null) {
			Category cc = ao.getCategory();
			boolean lightboxable = cc != Category.folder && cc != Category.webPage && cc != Category.webLocation;
			
			backgroundAudioLocal.setVisible(cc == Category.folder);
			backgroundAudioLabel.setVisible(cc == Category.folder);
			useInSlider.setVisible(lightboxable);
			panorama.setVisible(lightboxable);
			hideLocation.setVisible(lightboxable);
			//hideFotomoto.setVisible(lightboxable);
			//fotomotoCollection.setVisible(lightboxable);
			//fotomotoCollectionLabel.setVisible(lightboxable);
		}
	}
	
	public ImageDataUI(JAlbumContext context, SmartResourceBundle texts) {
		
		super(context);
		//setOpaque(true);
		backgroundAudioLabel.setText(texts.getString("ui.backgroundMusic"));
		useInSlider.setText(texts.getString("ui.useInHeroSlider"));
		panorama.setText(texts.getString("ui.panorama"));
		hideLocation.setText(texts.getString("ui.hideLocation"));
		//fotomotoCollection.addItem(new Item("", texts.getString("ui.default") + " (" + texts.getString("ui.forSale") + ")"));
		//fotomotoCollection.addItem(new Item("notForSale", texts.getString("ui.notForSale")));
		//fotomotoCollection.addItem(new Item("shareOnly", texts.getString("ui.shareOnly")));
		//fotomotoCollection.addItem(new Item("forSale", texts.getString("ui.forSale")));
		//fotomotoCollection.setEditable(true);
		//fotomotoCollectionLabel.setText(texts.getString("ui.fotomotoCollection"));
		hideFotomoto.setText(texts.getString("ui.hideFotomoto"));
		hideFotomoto.setToolTipText(texts.getString("ui.hideFotomotoInfo"));
		shopDiscountRateLocal.setToolTipText(texts.getString("ui.shopDiscountRateInfo1"));
		shopOptionsLocal.setToolTipText(texts.getString("ui.shopOptionsInfo"));
		shopOptionsLocal.setText("");
		shopOptionsLocal.setEditable(true);
		shopOptionsLocal.setLineWrap(true);
		shopOptionsLocal.setWrapStyleWord(true);

		add("", backgroundAudioLabel);
		add("br hfill", backgroundAudioLocal);
		add("", useInSlider);
		add("br", panorama);
		add("br", hideLocation);
		//add("br", fotomotoCollectionLabel);
		//add("tab", fotomotoCollection);
		add("br", hideFotomoto);
		add("br", new JLabel(texts.getString("ui.shopOptions")));
		add("br hfill vfill", shopPane);
		add("br", new JLabel(texts.getString("ui.shopDiscountRate")));
		add("tab", shopDiscountRateLocal);
		add(new JLabel("%"));
		add("br", new JLabel(texts.getString("ui.shopQuantityCap")));
		add("tab", shopQuantityCapLocal);

		init();
	}
}
